︠96d08e24-b19a-4ab2-b004-25438d155fb6i︠
%html
<p><span style="font-size: small;">Le TP d'aujourd'hui portera sur l'arithm&eacute;tique. On va notamment faire des calculs sur Z/nZ. De m&ecirc;me que la semaine derni&egrave;re il ne fallait pas confondre l'objet math&eacute;matique (ensemble) et sa repr&eacute;sentation informatique (liste), il faudra prendre garde cette semaine que les entiers peuvent r&eacute;pr&eacute;senter un entier math&eacute;matique ou bien un &eacute;l&eacute;ment de Z/nZ (une classe), suivant le contexte. </span></p>
<p><span style="font-size: small;">Si par exemple n=5 et qu'on veut tester l'&eacute;galit&eacute; entre 2 et 7, &eacute;crire 2==7 peut &ecirc;tre la r&eacute;ponse... ou pas.</span></p>

<p><span style="font-size: small;">Exercice 1 : &Eacute;crivez  une fonction DivEucl(a,b) qui renvoie le quotient et le reste de la  division euclidienne de a par b (entiers), en n'utilisant que la  soustraction (avec if, for et while, bien s&ucirc;r).</span></p>

︡dc740ef9-0d82-425d-91dd-37c2cd7fd957︡{"html": "<p><span style=\"font-size: small;\">Le TP d'aujourd'hui portera sur l'arithm&eacute;tique. On va notamment faire des calculs sur Z/nZ. De m&ecirc;me que la semaine derni&egrave;re il ne fallait pas confondre l'objet math&eacute;matique (ensemble) et sa repr&eacute;sentation informatique (liste), il faudra prendre garde cette semaine que les entiers peuvent r&eacute;pr&eacute;senter un entier math&eacute;matique ou bien un &eacute;l&eacute;ment de Z/nZ (une classe), suivant le contexte. </span></p>\n<p><span style=\"font-size: small;\">Si par exemple n=5 et qu'on veut tester l'&eacute;galit&eacute; entre 2 et 7, &eacute;crire 2==7 peut &ecirc;tre la r&eacute;ponse... ou pas.</span></p>\n\n<p><span style=\"font-size: small;\">Exercice 1 : &Eacute;crivez  une fonction DivEucl(a,b) qui renvoie le quotient et le reste de la  division euclidienne de a par b (entiers), en n'utilisant que la  soustraction (avec if, for et while, bien s&ucirc;r).</span></p>"}︡
︠0aacfe6e-3185-4b94-9a1d-ae5bb8d3c314︠
def DivEucl(a,b):
    q = 0
    r = a
    while r>=b:
        q+=1
        r-=b
    return (q,r)
︡3e965e53-ae74-4ca2-b39e-47a54fc40236︡︡
︠cbdd3e83-2433-47d0-b891-aced3bc69bedi︠
%html
<p><span style="font-size: small;">Exercice 2 : Programmez l'algorithme d'Euclide en utilisant l'exercice 1. On  rappelle que l'algorithme se d&eacute;roule de la mani&egrave;re suivante :</span></p>
<p><span style="font-size: small;">- On divise a par b, obtenant q et r ;</span></p>
<p><span style="font-size: small;">- on divise b par r, obtenant q' et r'</span></p>
<p><span style="font-size: small;">- et ainsi de suite. Le r&eacute;sultat renvoy&eacute; correspond au dernier reste non nul.</span></p>

︡82cffd89-86ee-42ed-896d-43122cc3e7bb︡{"html": "<p><span style=\"font-size: small;\">Exercice 2 : Programmez l'algorithme d'Euclide en utilisant l'exercice 1. On  rappelle que l'algorithme se d&eacute;roule de la mani&egrave;re suivante :</span></p>\n<p><span style=\"font-size: small;\">- On divise a par b, obtenant q et r ;</span></p>\n<p><span style=\"font-size: small;\">- on divise b par r, obtenant q' et r'</span></p>\n<p><span style=\"font-size: small;\">- et ainsi de suite. Le r&eacute;sultat renvoy&eacute; correspond au dernier reste non nul.</span></p>"}︡
︠3c0c319f-d629-4abe-9ddf-792e49968420︠
def Euclide(a,b):
    r1 = a
    r2 = b
    while r2!=0:
        q,r = DivEucl(r1,r2)
        r1=r2
        r2=r
    return r1
︡b3a5deab-6d0c-400a-a0de-a2fe88bb5517︡︡
︠a64aa009-7977-4e2a-9e89-64092ac2c9d2︠
Euclide(26,39)
︡17e8b9d4-21e6-4bee-8ffb-644d9f7b63c4︡{"stdout": "13"}︡
︠825406d8-643b-4111-91d1-d7e6e9f579f9i︠
%html
<p><span style="font-size: small;">Exercice 3  : Gr&acirc;ce &agrave; l'exercice 1, &eacute;crivez une fonction qui &agrave; un entier associe  l'&eacute;l&eacute;ment de sa classe compris entre 0 et n-1. Puis, &eacute;crivez des  fonctions qui testent l'&eacute;galit&eacute; et qui effectuent l'addition et la  multiplication dans Z/nZ.</span></p>

︡f461d531-083e-4f31-82ba-8ddc29b4a278︡{"html": "<p><span style=\"font-size: small;\">Exercice 3  : Gr&acirc;ce &agrave; l'exercice 1, &eacute;crivez une fonction qui &agrave; un entier associe  l'&eacute;l&eacute;ment de sa classe compris entre 0 et n-1. Puis, &eacute;crivez des  fonctions qui testent l'&eacute;galit&eacute; et qui effectuent l'addition et la  multiplication dans Z/nZ.</span></p>"}︡
︠c88e9dbc-3d16-4308-ac27-f655f80e058e︠
def Classe(a,n):
    q,r = DivEucl(a,n)
    return r                                 # En fait, on peut aussi écrire a%n, mais je voulais utiliser l'exercice 1.
    
def Egalite(a,b,n):
    return (Classe(a,n) == Classe(b,n))

def Addition (a,b,n):
    return Classe(a+b,n)
    
def Multplication (a,b,n):
    return Classe(a*b,n)
︡9976b190-e5ea-450b-8d67-1c32b1033646︡︡
︠6220df22-d370-4ce9-9744-cadba1b5a8d8i︠
%html
<p><span style="font-size: small;">En d&eacute;duire une fonction Divise(a,b,n) qui teste si a divise b dans Z/nZ </span><span style="font-size: small;">(il existe k tel que ka=b).</span></p>

︡ce95af58-c5ca-416e-968f-504651cbe850︡{"html": "<p><span style=\"font-size: small;\">En d&eacute;duire une fonction Divise(a,b,n) qui teste si a divise b dans Z/nZ </span><span style=\"font-size: small;\">(il existe k tel que ka=b).</span></p>"}︡
︠1345f69d-c3fa-4987-814d-0eb541d5304a︠
def Divise (a,b,n):
    for k in range(n):
        if Egalite(k*a,b,n): return True
    return False
︡f90cd423-223c-4221-a201-a5945bb76316︡︡
︠cc248b50-21ce-4aa4-9b9c-f3d4ce5f8417i︠
%html
<p><span style="font-size: small;">Vous avez appris qu'un &eacute;l&eacute;ment de Z/nZ est soit inversible (i.e. diviseur de 1), soit diviseur de z&eacute;ro. En vous inspirant de la question pr&eacute;c&eacute;dente, &eacute;crivez une fonction Diviseur(a,n) qui indique dans quel cas on est et qui renvoie un &eacute;l&eacute;ment k de Z/nZ tel que ka = 0 ou 1, suivant le cas (k non nul, bien sur). <br /></span></p>

︡af4f44e0-83d7-4848-bf9b-200ea28b1667︡{"html": "<p><span style=\"font-size: small;\">Vous avez appris qu'un &eacute;l&eacute;ment de Z/nZ est soit inversible (i.e. diviseur de 1), soit diviseur de z&eacute;ro. En vous inspirant de la question pr&eacute;c&eacute;dente, &eacute;crivez une fonction Diviseur(a,n) qui indique dans quel cas on est et qui renvoie un &eacute;l&eacute;ment k de Z/nZ tel que ka = 0 ou 1, suivant le cas (k non nul, bien sur). <br /></span></p>"}︡
︠ee53c99d-423d-4dd5-83c2-0844d7051234i︠
%html
<p><span style="font-size: small;">Exercice 4 : On va repr&eacute;senter un polyn&ocirc;me de degr&eacute; 3&nbsp; aX&sup3;+bX&sup2;+cX+d comme un tuple (a,b,c,d). &Eacute;crivez une fonction Polynul(a,b,c,d,n) qui teste si </span><span style="font-size: small;">aX&sup3;+bX&sup2;+cX+d = 0</span><span style="font-size: small;"> pour toute valeur de X </span><span style="font-size: small;">(dans Z/nZ)</span><span style="font-size: small;">.&nbsp;</span></p>

︡8e3e318a-94f5-47fb-add8-a3e7c78da4f8︡{"html": "<p><span style=\"font-size: small;\">Exercice 4 : On va repr&eacute;senter un polyn&ocirc;me de degr&eacute; 3&nbsp; aX&sup3;+bX&sup2;+cX+d comme un tuple (a,b,c,d). &Eacute;crivez une fonction Polynul(a,b,c,d,n) qui teste si </span><span style=\"font-size: small;\">aX&sup3;+bX&sup2;+cX+d = 0</span><span style=\"font-size: small;\"> pour toute valeur de X </span><span style=\"font-size: small;\">(dans Z/nZ)</span><span style=\"font-size: small;\">.&nbsp;</span></p>"}︡
︠7af134b9-284e-4ba6-ae98-c5d7f109ab6di︠
%html
<p><span style="font-size: small;">Exercice  5 : &Eacute;crivez  une fonction CribleErathost&egrave;ne(n) qui construit une liste  allant de 2 &agrave;  n, puis ne laisse que les nombre premiers. Pour cela : </span></p>
<p><span style="font-size: small;">- Prendre les &eacute;l&eacute;ments de la liste un par un ; </span></p>
<p><span style="font-size: small;">- Supprimer tous ses multiples de la liste (sauf lui-m&ecirc;me !) ; </span></p>
<p><span style="font-size: small;">- Prendre l'&eacute;l&eacute;ment suivant, et ainsi de suite. </span></p>
<p><span style="font-size: small;">Vous   aurez sans doute besoin de [0]*n qui construit une liste de taille n   remplie de 0. Pour faire une boucle for qui fait des sauts, consultez   l'aide de "range" (avec "range?"). Rappelez-vous le TD pr&eacute;c&eacute;dent : quand peut-on s'arr&ecirc;ter ?<br /></span></p>

︡7f924bef-076f-4410-a181-6f44bc46850a︡{"html": "<p><span style=\"font-size: small;\">Exercice  5 : &Eacute;crivez  une fonction CribleErathost&egrave;ne(n) qui construit une liste  allant de 2 &agrave;  n, puis ne laisse que les nombre premiers. Pour cela : </span></p>\n<p><span style=\"font-size: small;\">- Prendre les &eacute;l&eacute;ments de la liste un par un ; </span></p>\n<p><span style=\"font-size: small;\">- Supprimer tous ses multiples de la liste (sauf lui-m&ecirc;me !) ; </span></p>\n<p><span style=\"font-size: small;\">- Prendre l'&eacute;l&eacute;ment suivant, et ainsi de suite. </span></p>\n<p><span style=\"font-size: small;\">Vous   aurez sans doute besoin de [0]*n qui construit une liste de taille n   remplie de 0. Pour faire une boucle for qui fait des sauts, consultez   l'aide de \"range\" (avec \"range?\"). Rappelez-vous le TD pr&eacute;c&eacute;dent : quand peut-on s'arr&ecirc;ter ?<br /></span></p>"}︡
︠65915fcf-3403-420b-a81b-feedbe936e8bi︠
%html
<p><span style="font-size: small;">Exercice 6 : &Eacute;crire une fonction Factorisation(n) qui factorise un entier n en facteurs premiers. Utilisez la question pr&eacute;c&eacute;dente et demandez-vous comment vous feriez &agrave; la main (on ne cherche pas &agrave; &ecirc;tre efficace). Renvoyez le r&eacute;sultat sous la forme que vous pr&eacute;f&eacute;rez, par exemple une liste de couples (facteur, multiplicit&eacute;), i.e. 40 = 2&sup3;.5 -&gt; [(2,3),(5,1)]. </span></p>

︡9cdf8ec0-6f7f-4221-a3d9-696b2af8a634︡{"html": "<p><span style=\"font-size: small;\">Exercice 6 : &Eacute;crire une fonction Factorisation(n) qui factorise un entier n en facteurs premiers. Utilisez la question pr&eacute;c&eacute;dente et demandez-vous comment vous feriez &agrave; la main (on ne cherche pas &agrave; &ecirc;tre efficace). Renvoyez le r&eacute;sultat sous la forme que vous pr&eacute;f&eacute;rez, par exemple une liste de couples (facteur, multiplicit&eacute;), i.e. 40 = 2&sup3;.5 -&gt; [(2,3),(5,1)]. </span></p>"}︡
︠9894566b-877c-4e1b-b4b7-b4a7fa1c04bbi︠
%html
<p><span style="font-size: small;">Exercice 7: Calculons le pgcd d'une deuxi&egrave;me fa&ccedil;on ! Gr&acirc;ce &agrave; l'exercice pr&eacute;c&eacute;dent, &eacute;crivez une fonction pgcd(a,b) qui renvoie le pgcd de a et b en regardant leurs facteurs premiers communs. Comparez le r&eacute;sultat avec Euclide(a,b).</span></p>

︡1f9fbee7-c6f3-4e3f-ba34-6f7d841f9b88︡{"html": "<p><span style=\"font-size: small;\">Exercice 7: Calculons le pgcd d'une deuxi&egrave;me fa&ccedil;on ! Gr&acirc;ce &agrave; l'exercice pr&eacute;c&eacute;dent, &eacute;crivez une fonction pgcd(a,b) qui renvoie le pgcd de a et b en regardant leurs facteurs premiers communs. Comparez le r&eacute;sultat avec Euclide(a,b).</span></p>"}︡
︠635cef60-690e-44be-ad09-82b70bcec950i︠
%html
<p><span style="font-size: small;">Exercice 8 : &Eacute;crivez une fonction IndicatriceEuler(n) qui renvoie &phi;(n), c'est-&agrave;-dire le nombre d'&eacute;l&eacute;ments inversibles de Z/nZ. Utilisez la derni&egrave;re question de l'exercice 3.</span></p>

︡97e781c5-1ecf-45fc-87ad-3f8627394c32︡{"html": "<p><span style=\"font-size: small;\">Exercice 8 : &Eacute;crivez une fonction IndicatriceEuler(n) qui renvoie &phi;(n), c'est-&agrave;-dire le nombre d'&eacute;l&eacute;ments inversibles de Z/nZ. Utilisez la derni&egrave;re question de l'exercice 3.</span></p>"}︡
︠2039731c-a9cb-49c2-b90c-85c593afc8cai︠
%html
<p><span style="font-size: small;">Exercice bonus  (*) : &Eacute;crivez une fonction Reste(a,b,n) qui prend en entr&eacute;e un entier a,  un entier b (tr&egrave;s grand) et un entier n&gt;1, et qui calcule le reste  de a^b&nbsp; modulo n, le plus vite possible. Notamment, &eacute;viter de multiplier  par a b fois. Indice : observer la p&eacute;riodicit&eacute; et utiliser la division  euclidienne.</span></p>

︡f970c247-01bf-4c88-afbe-62929a8edcd1︡{"html": "<p><span style=\"font-size: small;\">Exercice bonus  (*) : &Eacute;crivez une fonction Reste(a,b,n) qui prend en entr&eacute;e un entier a,  un entier b (tr&egrave;s grand) et un entier n&gt;1, et qui calcule le reste  de a^b&nbsp; modulo n, le plus vite possible. Notamment, &eacute;viter de multiplier  par a b fois. Indice : observer la p&eacute;riodicit&eacute; et utiliser la division  euclidienne.</span></p>"}︡
︠c985f6bd-2ba1-45aa-8c75-d30a1ada5da0i︠
%html
<p><span style="font-size: small;">Exercice bonus 2 (*) : &Eacute;crire une fonction Diviseurs(a) qui renvoie la liste des diviseurs de a (sans tester tous les entiers &lt;a !). Utilisez la factorisation en facteurs premiers.</span></p>

︡da434a93-43ac-4dfa-857b-6c72250bf056︡{"html": "<p><span style=\"font-size: small;\">Exercice bonus 2 (*) : &Eacute;crire une fonction Diviseurs(a) qui renvoie la liste des diviseurs de a (sans tester tous les entiers &lt;a !). Utilisez la factorisation en facteurs premiers.</span></p>"}︡
︠94b25b58-149c-41a2-a215-704d15a7cc8bi︠
%html
<p><span style="font-size: small;"><br /></span></p>

︡569be929-9853-4981-84e1-46cbd09dcd66︡{"html": "<p><span style=\"font-size: small;\"><br /></span></p>"}︡
